/*****************************************************************************
 * bdump command / version 1.00                                              *
 *---------------------------------------------------------------------------*
 * t@C : bdump.c                                                      *
 * Tv       : t@C̃oCi_vo͂                           *
 *---------------------------------------------------------------------------*
 * [usage]                                                                   *
 * > bdump t@C                                                        *
 *---------------------------------------------------------------------------*
 * [return code]                                                             *
 * 0   : I                                                            *
 * 1   : s                                                            *
 * 2   : t@CȂ                                              *
 * 255 : ُI(͕WG[ɏo͂)                              *
 *****************************************************************************/

/*****************************************************************************
 * wb_t@Cǂݍ                                                    *
 *****************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define ERR_PRM 1
#define ERR_NOF 2
#define ERR_SYS 255

/*****************************************************************************
 * main()                                                                    *
 *****************************************************************************/
int main(argc,argv)
int argc;
char* argv[];
{
  FILE* fpInput;
  char cOut[256];
  char cAsc;
  char cAscStr[17];
  char cBuf[16];
  char cWork[8];
  long lAddr=0;
  int i;
  int iRead;
  int iAsc;

  /* `FbN */
  if(argc<2) {
    fprintf(stderr,"Argument error\n");
    fprintf(stderr,"[usage]\n");
    fprintf(stderr,"> bdump FileName\n");
    return ERR_PRM;
  }

  /* t@CJ */
  fpInput=fopen(argv[1],"rb");
  if(fpInput==NULL) {
    fprintf(stderr,"File not found. (%s)\n",argv[1]);
    return ERR_NOF;
  }

  fprintf(stdout,"ADDRESS  : 00 01 02 03 04 05 06 07 - 08 09 0A 0B 0C 0D 0E 0F : ASCII\n");
  fprintf(stdout,"---------+---------------------------------------------------+-----------------\n");

  /* C[v */
  while((iRead=fread(cBuf,1,sizeof(cBuf),fpInput))!=0) {
    memset(cAscStr,0,sizeof(cAscStr));
    sprintf(cOut,"%08X : ",lAddr);
    for(i=0;i<iRead;i++) {
      cAsc=cBuf[i];
      iAsc=cBuf[i] & 0xff;
      sprintf(cWork,"%02X ",iAsc);
      strcat(cOut,cWork);
      if(iAsc>=0x20 && iAsc<=0x7e) {
          cAscStr[i]=iAsc;
      } else {
          cAscStr[i]='.';
      }
      if(i==7) {
          strcat(cOut,"- ");
      }
    }
    for(;i<16;i++) {
      strcat(cOut,"   ");
      if(i==7) {
        strcat(cOut,"- ");
      }
    }
    strcat(cOut,": ");
    strcat(cOut,cAscStr);
    fprintf(stdout,"%s\n",cOut);
    lAddr+=iRead;
  }

  fclose(fpInput);
  return 0;
}

/* End of bdump.c */
